﻿# fuelle-zwei-tiefensuche-flache-liste.py
# Programm zum Füllen eines Containers mit Tiefensuche
# (Rucksackproblem)

# Globale Variable für die Stücke:
stuecke=[30,30,30,30,30,20,20,20,20,20]


def fuelle(stuecke, container_1, container_2, fassungsvermoegen):
    ##input((stuecke, container_1, container_2))
    # Fehlerbedingung Überfüllung testen
    if fassungsvermoegen<sum(container_1):
        return False
    if fassungsvermoegen<sum(container_2):
        return False
    if fassungsvermoegen==sum(container_1)&\
       fassungsvermoegen==sum(container_2):
        return container_1, container_2
    if len(stuecke)==0:
        return False
    # Zunächst mit dem Stück im ersten versuchen:
    ergebnis=fuelle(stuecke[1:],
                    container_1+stuecke[:1],
                    container_2,
                    fassungsvermoegen)
    if ergebnis: return ergebnis
    # Dann mit dem Stück im zweiten versuchen:
    ergebnis=fuelle(stuecke[1:],
                    container_1,
                    container_2+stuecke[:1],
                    fassungsvermoegen)
    if ergebnis: return ergebnis
    # In jedem Fall auch ohne das Stück versuchen:
    ergebnis=fuelle(stuecke[1:], container_1, container_2, fassungsvermoegen)
    if ergebnis: return ergebnis
    return False

def ausgabe(stuecke, c1, c2, fassungsvermoegen):
    print('Stücke:', stuecke, fassungsvermoegen,
          'Ergebnis:\n', fuelle(stuecke, c1, c2, fassungsvermoegen), '\n')


ausgabe( [30,30,20,20], [], [], 50)
ausgabe( stuecke, [], [], 80)
ausgabe( [30,30,30,30], [], [], 100)
ausgabe( [30,30,30,30,20,20], [], [], 90)
ausgabe( [30,30,30,30,20,20,20], [], [], 90)
ausgabe( stuecke, [], [], 90)

ausgabe( stuecke, [], [], 100)
