﻿# fuelle-tiefensuche-brute-force.py
# Programm zum Füllen eines Containers mit Tiefensuche
# (Rucksackproblem)
# Die hier beschriebene Variante ist die ganz "doofe", bei der
# erst am Schluss getestet wird, ob die Teile wirklich passten.


# Globale Variable für die Stücke:
stuecke=[30,30,30,30,30,20,20,20,20,20]


def fuelle(stuecke, container, fassungsvermoegen):
    if len(stuecke)==0:
        if fassungsvermoegen==sum(container):
            return container
        else:
            return False
    else:
        # Zunächst mit dem Stück versuchen:
        ergebnis=fuelle(stuecke[1:], container+stuecke[:1], fassungsvermoegen)
        if ergebnis:
            return ergebnis
        else:
            # In jedem Fall auch ohne das Stück versuchen:
            return fuelle(stuecke[1:], container, fassungsvermoegen)

### Tests
def ausgabe(stuecke, fassungsvermoegen):
    print('Stücke:', stuecke, fassungsvermoegen,
          'Ergebnis:\n', fuelle(stuecke, [], fassungsvermoegen), '\n')


ausgabe( stuecke, 80)
ausgabe( stuecke, 90)
ausgabe( stuecke, 100)
ausgabe( stuecke+[30], 100)
ausgabe( [30,30,30,30], 100)
##ausgabe( stuecke*10, 100)
##ausgabe( stuecke*10, 1000)
##ausgabe( [30,30,20,20], 50)
